<?php
if ( ! class_exists( 'Editorial_News_Agency_Plugin_Activation_WPElemento_Importer' ) ) {
    /**
     * Editorial_News_Agency_Plugin_Activation_WPElemento_Importer initial setup
     *
     * @since 1.6.2
     */

    class Editorial_News_Agency_Plugin_Activation_WPElemento_Importer {

        private static $editorial_news_agency_instance;
        public $editorial_news_agency_action_count;
        public $editorial_news_agency_recommended_actions;

        /** Initiator **/
        public static function get_instance() {
          if ( ! isset( self::$editorial_news_agency_instance) ) {
            self::$editorial_news_agency_instance = new self();
          }
          return self::$editorial_news_agency_instance;
        }

        /*  Constructor */
        public function __construct() {

            add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );

            // ---------- wpelementoimpoter Plugin Activation -------
            add_filter( 'editorial_news_agency_recommended_plugins', array($this, 'editorial_news_agency_recommended_elemento_importer_plugins_array') );

            $editorial_news_agency_actions                   = $this->editorial_news_agency_get_recommended_actions();
            $this->editorial_news_agency_action_count        = $editorial_news_agency_actions['count'];
            $this->editorial_news_agency_recommended_actions = $editorial_news_agency_actions['actions'];

            add_action( 'wp_ajax_create_pattern_setup_builder', array( $this, 'create_pattern_setup_builder' ) );
        }

        public function editorial_news_agency_recommended_elemento_importer_plugins_array($editorial_news_agency_plugins){
            $editorial_news_agency_plugins[] = array(
                    'name'     => esc_html__('WPElemento Importer', 'editorial-news-agency'),
                    'slug'     =>  'wpelemento-importer',
                    'function' => 'WPElemento_Importer_ThemeWhizzie',
                    'desc'     => esc_html__('We highly recommend installing the WPElemento Importer plugin for importing the demo content with Elementor.', 'editorial-news-agency'),               
            );
            return $editorial_news_agency_plugins;
        }

        public function enqueue_scripts() {
            wp_enqueue_script('updates');      
            wp_register_script( 'editorial-news-agency-plugin-activation-script', esc_url(get_template_directory_uri()) . '/includes/getstart/js/plugin-activation.js', array('jquery') );
            wp_localize_script('editorial-news-agency-plugin-activation-script', 'editorial_news_agency_plugin_activate_plugin',
                array(
                    'installing' => esc_html__('Installing', 'editorial-news-agency'),
                    'activating' => esc_html__('Activating', 'editorial-news-agency'),
                    'error' => esc_html__('Error', 'editorial-news-agency'),
                    'ajax_url' => esc_url(admin_url('admin-ajax.php')),
                    'wpelementoimpoter_admin_url' => esc_url(admin_url('admin.php?page=wpelemento-importer-tgmpa-install-plugins')),
                    'addon_admin_url' => esc_url(admin_url('admin.php?page=wpelementoimporter-wizard'))
                )
            );
            wp_enqueue_script( 'editorial-news-agency-plugin-activation-script' );

        }

        // --------- Plugin Actions ---------
        public function editorial_news_agency_get_recommended_actions() {

            $editorial_news_agency_act_count  = 0;
            $editorial_news_agency_actions_todo = get_option( 'recommending_actions', array());

            $editorial_news_agency_plugins = $this->editorial_news_agency_get_recommended_plugins();

            if ($editorial_news_agency_plugins) {
                foreach ($editorial_news_agency_plugins as $editorial_news_agency_key => $editorial_news_agency_plugin) {
                    $editorial_news_agency_action = array();
                    if (!isset($editorial_news_agency_plugin['slug'])) {
                        continue;
                    }

                    $editorial_news_agency_action['id']   = 'install_' . $editorial_news_agency_plugin['slug'];
                    $editorial_news_agency_action['desc'] = '';
                    if (isset($editorial_news_agency_plugin['desc'])) {
                        $editorial_news_agency_action['desc'] = $editorial_news_agency_plugin['desc'];
                    }

                    $editorial_news_agency_action['name'] = '';
                    if (isset($editorial_news_agency_plugin['name'])) {
                        $editorial_news_agency_action['title'] = $editorial_news_agency_plugin['name'];
                    }

                    $editorial_news_agency_link_and_is_done  = $this->editorial_news_agency_get_plugin_buttion($editorial_news_agency_plugin['slug'], $editorial_news_agency_plugin['name'], $editorial_news_agency_plugin['function']);
                    $editorial_news_agency_action['link']    = $editorial_news_agency_link_and_is_done['button'];
                    $editorial_news_agency_action['is_done'] = $editorial_news_agency_link_and_is_done['done'];
                    if (!$editorial_news_agency_action['is_done'] && (!isset($editorial_news_agency_actions_todo[$editorial_news_agency_action['id']]) || !$editorial_news_agency_actions_todo[$editorial_news_agency_action['id']])) {
                        $editorial_news_agency_act_count++;
                    }
                    $editorial_news_agency_recommended_actions[] = $editorial_news_agency_action;
                    $editorial_news_agency_actions_todo[]        = array('id' => $editorial_news_agency_action['id'], 'watch' => true);
                }
                return array('count' => $editorial_news_agency_act_count, 'actions' => $editorial_news_agency_recommended_actions);
            }

        }

        public function editorial_news_agency_get_recommended_plugins() {

            $editorial_news_agency_plugins = apply_filters('editorial_news_agency_recommended_plugins', array());
            return $editorial_news_agency_plugins;
        }

        public function editorial_news_agency_get_plugin_buttion($slug, $name, $function) {
                $editorial_news_agency_is_done      = false;
                $editorial_news_agency_button_html  = '';
                $editorial_news_agency_is_installed = $this->is_plugin_installed($slug);
                $editorial_news_agency_plugin_path  = $this->get_plugin_basename_from_slug($slug);
                $editorial_news_agency_is_activeted = (class_exists($function)) ? true : false;
                if (!$editorial_news_agency_is_installed) {
                    $editorial_news_agency_plugin_install_url = add_query_arg(
                        array(
                            'action' => 'install-plugin',
                            'plugin' => $slug,
                        ),
                        self_admin_url('update.php')
                    );
                    $editorial_news_agency_plugin_install_url = wp_nonce_url($editorial_news_agency_plugin_install_url, 'install-plugin_' . esc_attr($slug));
                    $editorial_news_agency_button_html        = sprintf('<a class="editorial-news-agency-plugin-install install-now button-secondary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($editorial_news_agency_plugin_install_url),
                        sprintf(esc_html__('Install %s Now', 'editorial-news-agency'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Install & Activate', 'editorial-news-agency')
                    );
                } elseif ($editorial_news_agency_is_installed && !$editorial_news_agency_is_activeted) {

                    $editorial_news_agency_plugin_activate_link = add_query_arg(
                        array(
                            'action'        => 'activate',
                            'plugin'        => rawurlencode($editorial_news_agency_plugin_path),
                            'plugin_status' => 'all',
                            'paged'         => '1',
                            '_wpnonce'      => wp_create_nonce('activate-plugin_' . $editorial_news_agency_plugin_path),
                        ), self_admin_url('plugins.php')
                    );

                    $editorial_news_agency_button_html = sprintf('<a class="editorial-news-agency-plugin-activate activate-now button-primary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($editorial_news_agency_plugin_activate_link),
                        sprintf(esc_html__('Activate %s Now', 'editorial-news-agency'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Activate', 'editorial-news-agency')
                    );
                } elseif ($editorial_news_agency_is_activeted) {
                    $editorial_news_agency_button_html = sprintf('<div class="action-link button disabled"><span class="dashicons dashicons-yes"></span> %s</div>', esc_html__('Active', 'editorial-news-agency'));
                    $editorial_news_agency_is_done     = true;
                }

                return array('done' => $editorial_news_agency_is_done, 'button' => $editorial_news_agency_button_html);
            }
        public function is_plugin_installed($slug) {
            $editorial_news_agency_installed_plugins = $this->get_installed_plugins(); // Retrieve a list of all installed plugins (WP cached).
            $editorial_news_agency_file_path         = $this->get_plugin_basename_from_slug($slug);
            return (!empty($editorial_news_agency_installed_plugins[$editorial_news_agency_file_path]));
        }
        public function get_plugin_basename_from_slug($slug) {
            $editorial_news_agency_keys = array_keys($this->get_installed_plugins());
            foreach ($editorial_news_agency_keys as $editorial_news_agency_key) {
                if (preg_match('|^' . $slug . '/|', $editorial_news_agency_key)) {
                    return $editorial_news_agency_key;
                }
            }
            return $slug;
        }

        public function get_installed_plugins() {

            if (!function_exists('get_plugins')) {
                require_once ABSPATH . 'wp-admin/includes/plugin.php';
            }

            return get_plugins();
        }
        public function create_pattern_setup_builder() {

            $edit_page = admin_url().'post-new.php?post_type=page&create_pattern=true';
            echo json_encode(['page_id'=>'','edit_page_url'=> $edit_page ]);

            exit;
        }

    }
}
/**
 * Kicking this off by calling 'get_instance()' method
 */
Editorial_News_Agency_Plugin_Activation_WPElemento_Importer::get_instance();